#ifndef PROBLEM_H
#define PROBLEM_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <vector>
#include <iostream>
using namespace std;

typedef vector<double> Data;
typedef vector<Data> Matrix;

/**
 * @brief The Problem class, geniki klasi ylopoihshs
 * problimaton beltistopoihshs.
 */
class Problem
{
protected:
    int dimension;
    Data left, right;
    Data bestx;
    double besty;
    int functionCalls;
public:
    /**
     * @brief Problem, synartisi dimioyrgias
     * @param n
     */
    Problem(int n);

    /**
     * @brief getDimension, epistrefei tin diastasi tou problimatos
     * @return
     */
    int getDimension() const;

    /**
     * @brief getSample, epistrefei ena neo tyxaio sample sto
     * pedio orismou tis synartisis
     * @return
     */
    Data getSample();
    /**
     * @brief setLeftMargin, orizei to aristero akro tou
     * problimatos veltistopoihsis
     * @param x
     */
    void setLeftMargin(Data &x);
    /**
     * @brief setRightMargin, orizei to dexi akro tou
     * problimatos veltistopoihshs
     * @param x
     */
    void setRightMargin(Data &x);
    /**
     * @brief getLeftMargin, epistrefei to aristero
     * akro tou problimatos veltistopoihshs
     * @return
     */
    Data getLeftMargin() const;
    /**
     * @brief getRightMargin, epistrefei to dexi akro
     * tou problimatos veltistopoihshs
     * @return
     */
    Data getRightMargin() const;
    /**
     * @brief funmin, epistrefei tin synartisi f(x)
     * @param x
     * @return
     */
    virtual double funmin(Data &x) = 0;
    /**
     * @brief gradient, epistrefei tin paragogo tis f(x)
     * @param x
     * @return
     */
    virtual Data gradient(Data &x) = 0;
    /**
     * @brief statFunmin Kalei prota tin funmin(x)
     * kai diatirei to bestvalue kai kanei update
     * ta function calls
     * @param x
     */
    double statFunmin(Data &x);
    double grms(Data &x);
    Data    getBestx() const;
    double  getBesty() const;
    int     getFunctionCalls() const;
    ~Problem();
};


#endif // PROBLEM_H
